-- Deja Mark

BINDING_HEADER_DEJAMARK = "DejaMark"
_G["BINDING_NAME_CLICK DejaMark:LeftButton"] = "Show Markers(Hold)"

local DMM_isClassic
local _, _, _, tocversion = GetBuildInfo()
if (tocversion < 20000) then
	DMM_isClassic = true
end

--[[Target Markers run backwards in the player/target frame dropdown menu with Skull = 8 thru Star = 1 and None = 0
DejaMark swaps Skull [8,8] and Moon [5,7] so that Skull is in the middle under the cursor.
Isntead of:
123
456
780
DejaMark's layout is:
123
486
750

DejaMark Marker icon layout:
1 Star		2 Circle	3 Diamond
4 Triangle	8 Skull		6 Square
7 Cross		5 Moon		0 None	
]]

World_Flares = { 
--[[k=Target Marker, v=World Flare]]
				--[[Icon = Target Marker, World Flare]]
--[[k=1]]	5,	--[[Star = TM1, WF5]] 
--[[k=2]]	6,	--[[Circle = TM2, WF6]] 
--[[k=3]]	3,	--[[Diamond = TM3, WF3]] 
--[[k=4]]	2,	--[[Triangle = TM4, WF2]] 
--[[k=5]]	7,	--[[Moon = TM5, WF7]] 
--[[k=6]]	1,	--[[Square = TM6, WF1]] 
--[[k=7]]	4,	--[[Cross = TM7, WF4]] 
--[[k=8]]	8,	--[[Skull = TM8, WF8]] 
--[[k=9]]	0,	--[[None = TM9, WF0]] 
}

local DejaMarkFrame=CreateFrame("Frame","DejaMarkFrame",UIParent)
DejaMarkFrame:SetClampedToScreen( true )
DejaMarkFrame:SetMovable(true)
DejaMarkFrame:EnableMouse(true)
DejaMarkFrame:SetSize(100,100)
DejaMarkFrame:SetScale(1.0)
DejaMarkFrame:Hide()

local t=DejaMarkFrame:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(DejaMarkFrame)
	t:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background")

for index = 1, 9 do -- Lua starts tables at 1 isntead of 0... so below I do lots of equating 9 to 0 as an index...
	-- Button = CreateFrame("Button", "DejaMarkIconButton"..index, self); --Use "SecureActionButtonTemplate" if using macros
	Button = CreateFrame("Button", "DejaMarkIconButton"..index, DejaMarkFrame, "SecureActionButtonTemplate"); --Use "SecureActionButtonTemplate" if using macros
	Button:SetWidth(32);
	Button:SetHeight(32);
	Button:SetID(index);
	if(index==9)then
		Button:SetPoint("BOTTOMRIGHT");
	elseif(index==1)then
		Button:SetPoint("TOPLEFT");
	elseif(index==2)then
		Button:SetPoint("TOP");
	elseif(index==3)then
		Button:SetPoint("TOPRIGHT");
	elseif(index==4)then
		Button:SetPoint("LEFT");
	elseif(index==5)then
		Button:SetPoint("BOTTOM");
	elseif(index==6)then
		Button:SetPoint("RIGHT");
	elseif(index==7)then
		Button:SetPoint("BOTTOMLEFT");
	elseif(index==8)then
		Button:SetPoint("CENTER");
	end

	Button.Texture = Button:CreateTexture(Button:GetName().."NormalTexture", "ARTWORK");
	if(index==9)then
		Button.Texture:SetTexture("Interface\\BUTTONS\\UI-GroupLoot-Pass-Up");
	else
		Button.Texture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons");
		SetRaidTargetIconTexture(Button.Texture, index); -- Blizzard specific function that centers sprite texture via index but doesn't include clearing all marks
	end

	Button.Texture:SetAllPoints();
	Button:RegisterForClicks("LeftButtonUp","RightButtonUp");
	-- Button:SetScript("OnClick", DejaMarkButton_OnClick); --Comment out if using macros
	
	Button:SetScript("OnEnter", function(self, ...)
		self.Texture:ClearAllPoints();
		self.Texture:SetPoint("TOPLEFT", -5, 5);
		self.Texture:SetPoint("BOTTOMRIGHT", 5, -5);
	end);
	
	Button:SetScript("OnLeave", function(self, ...)
		self.Texture:SetAllPoints();
	end);

	if DMM_isClassic then --Check for Classic which doesn't have world markers. This doesn't use macros and won't have the custom script warning popup.
		Button:SetScript("OnClick", function (self, button, down)
			if (index == 9) then
				if (button=="LeftButton") then
 					SetRaidTarget("target", 0)
				end
				if (button=="RightButton") then
					for index = 1, 9 do
						SetRaidTarget("player", index)
					end
				end
			else
				local targetindex = GetRaidTargetIndex("target")
				if (targetindex == index) then
					SetRaidTarget("target", 0)
				else
					SetRaidTarget("target", index)
				end
			end
		end)
	else
		Button:SetAttribute("type","macro") -- /tm on left click, /wm on right click

		wfIndexValue = World_Flares[Button:GetID()]
		-- print(index, wfIndexValue)
		if (wfIndexValue==0) then --Because Lua tables don't start with 0 use the values isntead of the keys
			Button:SetAttribute("macrotext",'/run local function dmClearTargetmarkers()SetRaidTarget("player",0)end PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)if SecureCmdOptionParse("[btn:1]") then for k,v in ipairs (World_Flares) do SetRaidTarget("player",v)C_Timer.After(0.3, dmClearTargetmarkers)end end\n/cwm [btn:2] all')
		else
			-- Button:SetAttribute("macrotext",'/run print('..index..', '..wfIndexValue..')') --Onclick/k,v debugging comment out the next line as only ending SetAttribute runs
			Button:SetAttribute("macrotext",'/run PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON) if SecureCmdOptionParse("[btn:1]") then SetRaidTargetIcon("target", '..index..') end\n/wm [btn:2] '..wfIndexValue..'\n/cwm [btn:2] '..wfIndexValue..'')
		end
	end
end

--toggle frame, has no visible parts. exists as a place to accept a click run a snippet
local toggleframe = CreateFrame("Button","DejaMark",UIParent,"SecureHandlerClickTemplate")
	toggleframe:RegisterEvent("PLAYER_TARGET_CHANGED")
	toggleframe:RegisterForClicks("AnyUp", "AnyDown")
	toggleframe:SetFrameRef("ParentFrame",DejaMarkFrame)
	
	toggleframe:SetAttribute("_onclick",[[
		ParentFrame = self:GetFrameRef("ParentFrame")
		if down then
			ParentFrame:SetPoint("CENTER","$cursor")
			ParentFrame:Show()
		else
			ParentFrame:Hide()
		end
	]])